#include<iostream.h>
#include<conio.h>
#include<process.h>
#include<string.h>
struct node
{
 int data;
 struct node *left;
 struct node *right;
};
typedef struct node *t;
class bintree
{
 t tree;
 public:
	bintree()
	{
	 tree=NULL;
	}
	void insert(int);
	void inorder(t);
	void preorder(t);
	void postorder(t);
	t tree_ret();
};
void bintree::insert(int item)
{
 t cur,prev,temp;
 temp=new (struct node);
 temp->data=item;
 temp->left=temp->right=NULL;
 if(tree==NULL)
 {
  tree=temp;
 }
 else
 {
  prev=NULL;
  cur=tree;
  while(cur!=NULL)
  {
   prev=cur;
   if(item<cur->data)
	cur=cur->left;
   else
	cur=cur->right;
  }
  if(item<prev->data)
	prev->left=temp;
  else
	prev->right=temp;
 }
}
void bintree::inorder(t tree)
{
 t temp;
 temp=tree;
 if(temp!=NULL)
 {
  inorder(temp->left);
  cout<<temp->data<<"\t";
  inorder(temp->right);
 }
}
void bintree::preorder(t tree)
{
 t temp;
 temp=tree;
 if(temp!=NULL)
 {
  cout<<temp->data<<"\t";
  preorder(temp->left);
  preorder(temp->right);
 }
}
void bintree::postorder(t tree)
{
 t temp;
 temp=tree;
 if(temp!=NULL)
 {
  postorder(temp->left);
  postorder(temp->right);
  cout<<temp->data<<"\t";
 }
}
t bintree::tree_ret()
{
 return tree;
}
void main()
{
 bintree bt;
 t tree;
 int ch;
 int item;
 while(1)
 {
  clrscr();
  cout<<"Enter u r choice\n1:insert\t2:display\t3:exit\n";
  cin>>ch;
  switch(ch)
  {
    case 1:cout<<"enter the data to insert:";
	   cin>>item;
	   bt.insert(item);
	   break;
    case 2:cout<<"The contents of the binary tree are:\n";
	   cout<<"Inorder:";
	   tree=bt.tree_ret();
	   bt.inorder(tree);
	   cout<<endl;
	   cout<<"preorder:";
	   tree=bt.tree_ret();
	   bt.preorder(tree);
	   cout<<endl;
	   cout<<"postorder:";
	   tree=bt.tree_ret();
	   bt.postorder(tree);
	   cout<<endl;
	   getch();
	   break;
    default:
	    cout<<"\nprogram is terminated";
	    exit(0);
  }
 }
}