//Program to implement a queue

#include<iostream.h>
#include<stdio.h>
#include<conio.h>

const int size = 50;

template <class T>
class queue
{
  T a[size];
  int front;
  int rear;

public:

  queue()
  {
    front = 0;
    rear = -1;
  }

  int isempty()
  {
    if(front>rear)
    return 1;
    else
    return 0;
  }

  void insert(T x);
  T remove();
  void display();
};

template<class T> void queue<class T>::insert(T x)
{
  if (rear == size - 1)
  {
    cout<<"Queue Full\n";
    return;
  }
  a[++rear] = x;
}

template<class T> T queue<class T>::remove()
{
  if (isempty())
  {
    cout<<"Queue Empty\n";
    return 0;
  }
  return a[front++];
}

template<class T>void queue<class T>::display()
{
  if (isempty())
  {
    cout<<"Queue Empty\n";
    return;
  }
  for (int i = front; i <=rear; i++)
    cout<<a[i]<<"\t";
  cout<<endl;
}

void main()
{
  clrscr();

  queue<int> qint;

  queue<double> qdouble;

  int choice;

  do
  {
    cout<<"\n\n";

    cout<<"1. Add an integer\n";
    cout<<"2. Delete an integer\n";
    cout<<"3. Display the integer queue\n";

    cout<<"4. Add a double\n";
    cout<<"5. Delete a double\n";
    cout<<"6. Display the double queue\n";

    cout<<"7. Exit\n\n";

    cout<<"Enter your choice: ";
    cin>>choice;

    switch(choice)
    {
      case 1: int x;
	      cout<<"Enter the element: ";
	      cin>>x;
	      qint.insert(x);
	      break;

      case 2: if (!qint.isempty())
		cout<<"Front element: "<<qint.remove();
	      else
		cout<<"Queue empty\n";
	      break;

      case 3: cout<<"Integer queue: ";
	      qint.display();
	      break;

      case 4: double y;
	      cout<<"Enter the element: ";
	      cin>>y;
	      qdouble.insert(y);
	      break;

      case 5: if (!qdouble.isempty())
		cout<<"Front element: "<<qdouble.remove();
	      else
		cout<<"Queue empty\n";
	      break;

      case 6: cout<<"Double queue: ";
	      qdouble.display();
	      break;

      case 7: break;

      default: cout<<"Invalid input\n";

    }
  } while(choice != 7);
  getch();
}

